<?php
/**
 * Googlebot Tracker Class 
 * 
 * @version   1.0
 * @Author: WPX Hosting
 **/

namespace Classes;

class Google_Bot_Tracker {
	/**
	 * Simple static cache var
	 * @var array
	 */
	static protected $_cache = array();

	/**
	 * Add Service details to the database
	 * @param array $data
	 * @global wpdb $wpdb
	 * @global string $table_prefix
	 */

	/**
	 * Get list of all registered post types
	 * @global type $table_prefix
	 * @global type $wpdb
	 * @return type
	 */
	static function getPostTypes() {
		global $table_prefix, $wpdb;

		$table = $table_prefix . WPBW_TRACKER_LOG_TABLE;
		$sql = "SELECT DISTINCT `p_type` FROM ". $table;
		$rows = $wpdb->get_results($sql);
		$list = array();
		foreach ($rows as $row => $type) {
			if($type->p_type == '') {
				continue;
			}

			$list[$row] = $type->p_type;
		}

		return $list;
	}

	/**
	 * Get list of all registered user agents (Bot types)
	 * @global \Classes\type $table_prefix
	 * @global \Classes\type $wpdb
	 * @return type
	 */
	static function getBotAgents() {
		global $table_prefix, $wpdb;

		$table = $table_prefix . WPBW_TRACKER_LOG_TABLE;
		$sql = "SELECT DISTINCT `user_agent` FROM ". $table;
		$rows = $wpdb->get_results($sql);

		$list = array();
		foreach ($rows as $row=>$name) {
			$list[$row] = $name->user_agent;
		}

		return $list;
	}

	/**
	 * Clear or delete Googlebot log
	 * @global \Classes\type $table_prefix
	 * @global \Classes\type $wpdb
	 * @return type
	 */
	static function deleteLogData() {
		global $table_prefix, $wpdb;

		$table = $table_prefix . WPBW_TRACKER_LOG_TABLE;
		$data = array();
		if (($_POST['s_date'] != '') || ($_POST['e_date'] != '')) {
			$data['action'] = 'delete';

			$start_date = ($_POST['s_date'] != '') ? date('Y-m-d', strtotime($_POST['s_date'])) : date('Y-m-d', strtotime('10.10.2010'));
			$end_date = ($_POST['e_date'] != '') ? date('Y-m-d', strtotime($_POST['e_date'])) : date('Y-m-d');

			$sql = "DELETE FROM ". $table ." WHERE DATE(`date`) BETWEEN '". $start_date ."'  AND '". $end_date ."'";

			$result = $wpdb->query($sql);
		} else {
			$data['action'] = 'truncate';
			$sql = "TRUNCATE TABLE ". $table;
			$result = $wpdb->query($sql);
		}

		$data['result'] = $result;

		return $data;
	} 
}
?>
