<?php
/**
 * WPBW_Admin_Log Class 
 * 
 * @version   1.0
 * @Author: WPX Hosting
 **/

namespace Classes;
require_once WPBW_TRACKER_PLUGIN_DIR . 'wp-botwatch.php';


class WPBW_Admin_Log {

 
/**
 * Add Service details to the database
 * @param string $str
 * 
 * @return string $new_str
 */
   
  /**
   * Combines data from 'admin history table' and 'admin history contexts table' then returns the composite string
   * @param type $history_id
   * @param type $str
   * @return string
   */  
    static function substituteKeysWithValues($history_id, $str) {
        $data = array();
        $new_str = '';
        
        $first_open_parenthesis = strpos($str, '{');
        $first_close_parenthesis = strpos($str, '}');
        $data['history_id'] = $history_id;
        $data['first_key'] = substr($str, $first_open_parenthesis + 1, $first_close_parenthesis - $first_open_parenthesis - 1);

        $part_str = substr($str, $first_close_parenthesis + 1);
        $second_open_parenthesis = strpos($part_str, '{');
        if ($second_open_parenthesis) {
            $second_close_parenthesis = strpos($part_str, '}');
            $data['second_key'] = substr($part_str, $second_open_parenthesis + 1, $second_close_parenthesis - $second_open_parenthesis - 1);
        }
        

        $values = WPBW_Admin_Log::getValues($data);

        $first_str_part = substr($str, 0, $first_open_parenthesis);
        if (count($values) > 1) {
            $second_str_part = substr($str, $first_close_parenthesis + 1, $second_open_parenthesis ); 
            $last_str_part = substr($part_str, $second_close_parenthesis + 1,  strlen($part_str) - $second_close_parenthesis);
            $new_str = $first_str_part . $values[0]. $second_str_part . $values[1]. $last_str_part;
        } else {
            $last_str_part = substr($str, $first_close_parenthesis + 1,  strlen($str) - $first_close_parenthesis);
            $new_str = $first_str_part . $values[0]. $last_str_part;
        }
        return $new_str;
    }
    
    /**
     * Get values from 'admin history contexts table' by history_id and keys in the message
     * @global type $table_prefix
     * @global type $wpdb
     * @param type $data
     * @return type
     */
    static function getValues($data) {
        $values = array();
        global $table_prefix, $wpdb;        
        $table_history = $table_prefix . WPBW_TRACKER_ACTIONS_TABLE;
        $table_context = $table_prefix . WPBW_TRACKER_ACTIONS_CONTEXTS_TABLE;
        
            $sql = "SELECT `value` FROM `{$table_context}` WHERE `history_id` = ";
            $sql .= $data['history_id']. " AND (`key` = '";
            $sql .= $data['first_key'];
            
            if (count($data) > 2) {
                $sql .= "' OR `key` = '";
                $sql .= $data['second_key'];
            } 
            $sql .= "');"; 
       
            $rows = $wpdb->get_results($sql);

            $list = array();
            foreach ($rows as $row=>$type) {
                $values[$row] = $type->value;
            }

        return $values;
    }
    
    /**
     * Clear or delete 'admin history table'
     * @global \Classes\type $table_prefix
     * @global \Classes\type $wpdb
     * @return type
     */
    static function deleteAdminActionsLog() {
        global $table_prefix, $wpdb;        
        $table = $table_prefix . WPBW_TRACKER_ACTIONS_TABLE;
        
        $data = array();
        $IDs = array();
        
        if (($_POST['start_date'] != '') || ($_POST['end_date'] != ''))  {
            $data['action'] = 'delete';

            $start_date = ($_POST['start_date'] != '') ? date('Y-m-d', strtotime($_POST['start_date'])) : date('Y-m-d', strtotime('10.10.2010'));
            $end_date = ($_POST['end_date'] != '') ? date('Y-m-d', strtotime($_POST['end_date'])) : date('Y-m-d');

            
            $sql = "SELECT ID FROM ".$table. " WHERE DATE(`date`) BETWEEN '" . $start_date . "'  AND '" . $end_date ."'";

            $ID_list = $wpdb->get_results($sql);
            foreach ($ID_list as $row => $ID){
                $IDs[$row] = $ID->ID;
            }
            $ids_str = implode(',', $IDs);
            $sql = "DELETE FROM ".$table. " WHERE DATE(`date`) BETWEEN '" . $start_date . "'  AND '" . $end_date ."'";
            $data['result_actions'] = $wpdb->query( $sql );
            $data['result_context'] = WPBW_Admin_Log::deleteAdminActionsContextLog($ids_str);
        } else {
            $data['action'] = 'truncate';
            $sql = "TRUNCATE TABLE " .$table;
            $data['result_actions'] = $wpdb->query( $sql );
            $data['result_context'] = WPBW_Admin_Log::deleteAdminActionsContextLog();
        }
        
        return $data;
        
    } 
    
    /**
     * Clear or Delete 'admin history contexts table'
     * @global \Classes\type $table_prefix
     * @global \Classes\type $wpdb
     * @param type $ids
     * @return type
     */
    static function deleteAdminActionsContextLog($ids = '') {
        global $table_prefix, $wpdb;        
        $table = $table_prefix . WPBW_TRACKER_ACTIONS_CONTEXTS_TABLE;
        if ($ids != '') {
            $sql = "DELETE FROM " .$table. " WHERE history_id IN (". $ids .")";
            
            $result = $wpdb->query( $sql );
        } else {
            $sql = "TRUNCATE TABLE " .$table;
            $result = $wpdb->query( $sql );
        }
        
        return $result;
    } 
}
    
