<style type="text/css">
	#chart {
		height: 500px;
		font: 13px sans-serif;
	}
	.node rect {
		fill-opacity: .9;
		shape-rendering: crispEdges;
		stroke-width: 0;
	}
	.node text {
		text-shadow: 0 1px 0 #fff;
	}
	.link {
		fill: none;
		stroke: #000;
		stroke-opacity: .2;
	}
</style>
<div class="wrap">
	<h2><?php _e('Google bot indexing flow', 'gbt'); ?></h2>

	<form action="" method="get">
		<input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
		<ul class="fields-container">
			<li>
				<label for="start_date"><?php echo __('Start Date', 'gbt'); ?></label>
				<input type="text" value="<?php echo @$_REQUEST['start_date']; ?>" name="start_date" id="start_date">
			</li>
			<li>
				<label for="search-submit"><br /></label>
				<input type="submit" value="<?php echo __('Filter', 'gbt'); ?>" class="button" id="search-submit" name=""></p>
			</li>
			<li>
				<button id="save-as-image" class="button" type="button" onclick="printChart();" style="margin-top:23px;"><?php echo __('Save as png', 'gbt'); ?></button></p>
			</li>
		</ul>
	</form>

	<div style="clear:both"></div>

	<?php
	$class = new WPBW_Indexsing_Flow();

	$date = (isset($_GET['start_date']) && $_GET['start_date'] != '') ? date('Y-m-d', strtotime($_GET['start_date'])) : '';

	$json = $class->fetch($date);

	$directory = dirname(__FILE__) . '/../jsons/';

	if (!is_dir($directory)) {
		mkdir($directory, 0755, true);
	}

	file_put_contents($directory . 'flow.json', $json);
	
	$jsonUrl = plugin_dir_url(__FILE__);
	
	echo $jsonUrl;
	?>

	<div class="notice notice-info">
		<p><?php _e('This shows how the google bot moved through the pages! If one page was visited, it wont be shown again.', 'gbt'); ?></p>
	</div>

	<script src="//d3js.org/d3.v3.min.js"></script>
	<script type="text/javascript" src="<?php echo plugins_url(); ?>/wp-botwatch/assets/js/sankey.js"></script>
	<script src="https://rawgit.com/misoproject/d3.chart/master/d3.chart.min.js"></script>
	<script src="https://rawgit.com/q-m/d3.chart.sankey/master/d3.chart.sankey.min.js"></script>

	<script type="text/javascript">
	var json = JSON.parse('<?php echo json_encode($json); ?>');

	var colors = {
		'environment': '#edbd00',
		'social': '#367d85',
		'animals': '#97ba4c',
		'health': '#f5662b',
		'research_ingredient': '#3f3e47',
		'fallback': '#9f9fa3'
	};
	d3.json(json, function (error, json) {
		var chart = d3.select("#sankey_basic").append("svg").chart("Sankey.Path");
		chart
				.name(label)
				.colorNodes(function (name, node) {
					return color(node, 1) || colors.fallback;
				})
				.colorLinks(function (link) {
					return color(link.source, 4) || color(link.target, 1) || colors.fallback;
				})
				.nodeWidth(15)
				.nodePadding(10)
				.spread(true)
				.iterations(0)
				.draw(json);
		function label(node) {
			return node.name.replace(/\s*\(.*?\)$/, '');
		}
		function color(node, depth) {
			var id = node.id.replace(/(_score)?(_\d+)?$/, '');
			if (colors[id]) {
				return colors[id];
			} else if (depth > 0 && node.targetLinks && node.targetLinks.length == 1) {
				return color(node.targetLinks[0].source, depth - 1);
			} else {
				return null;
			}
		}
	});
	</script>

	<div id="sankey_basic" style="width:100%; height:700px;"></div>
	<div id="chart-image"></div>
</div>
<script type="text/javascript" src="<?php echo plugins_url('wp-botwatch') ?>/assets/js/main.js"></script>
<script type="text/javascript" src="<?php echo plugins_url('wp-botwatch') ?>/assets/js/jquery-ui-1.11.4/jquery-ui.min.js"></script>
<link rel="stylesheet" type="text/css" href="<?php echo plugins_url('wp-botwatch') ?>/assets/js/jquery-ui-1.11.4/jquery-ui.min.css" />
<link rel="stylesheet" type="text/css" href="<?php echo plugins_url('wp-botwatch') ?>/assets/css/style.css" />

<script type="text/javascript">
jQuery(document).ready(function ($) {
	$('#save-png').on('click', function () {
		var url = chart.getImageURI();
	});
});
</script>